define(["require", "exports"], function (require, exports) {
    "use strict";
    /**
     * The possible methods that can be used to fit the image.
     */
    (function (ImageFit) {
        /**
         * The image is not scaled. The image is centered and cropped within the content box.
         */
        ImageFit[ImageFit["center"] = 0] = "center";
        /**
         * The image is sized to maintain its aspect ratio while filling the element’s entire content box.
         */
        ImageFit[ImageFit["cover"] = 1] = "cover";
        /**
         * The image is scaled to match the size of the element's content box.
         */
        ImageFit[ImageFit["scale"] = 2] = "scale";
        /**
         * The image is not resized.
         */
        ImageFit[ImageFit["none"] = 3] = "none";
    })(exports.ImageFit || (exports.ImageFit = {}));
    var ImageFit = exports.ImageFit;
});
