"use strict";
var __extends = (this && this.__extends) || function (d, b) {
    for (var p in b) if (b.hasOwnProperty(p)) d[p] = b[p];
    function __() { this.constructor = d; }
    d.prototype = b === null ? Object.create(b) : (__.prototype = b.prototype, new __());
};
var React = require('react');
var ReactDOM = require('react-dom');
var LayerHost_1 = require('./LayerHost');
require('./Layer.scss');
var LAYER_HOST_ELEMENT_ID = 'ms-layer-host';
var _instance = 0;
var _layerHost;
var Layer = (function (_super) {
    __extends(Layer, _super);
    function Layer(props) {
        _super.call(this, props);
        this._layer = {
            id: String(_instance++),
            children: props.children
        };
    }
    Layer.prototype.render = function () {
        return (React.createElement("div", {className: 'ms-Layer'}));
    };
    Layer.prototype.componentWillMount = function () {
        if (!_layerHost) {
            var hostElement = document.createElement('div');
            hostElement.setAttribute('id', LAYER_HOST_ELEMENT_ID);
            document.body.appendChild(hostElement);
            var layerHost = ReactDOM.render((React.createElement(LayerHost_1.LayerHost, null)), hostElement);
            _layerHost = layerHost;
        }
    };
    Layer.prototype.componentDidMount = function () {
        _layerHost.addLayer(this._layer, this.props.onLayerMounted);
    };
    Layer.prototype.componentWillReceiveProps = function (props) {
        this._layer.children = props.children;
        _layerHost.updateLayer(this._layer);
    };
    Layer.prototype.componentWillUnmount = function () {
        _layerHost.removeLayer(this._layer);
    };
    return Layer;
}(React.Component));
exports.Layer = Layer;

//# sourceMappingURL=Layer.js.map
