import * as React from 'react';
import './Slider.scss';
import { ISliderProps } from './Slider.Props';
export interface ISliderState {
    value: number;
}
export declare enum ValuePosition {
    Previous = 0,
    Next = 1,
}
export declare class Slider extends React.Component<ISliderProps, ISliderState> {
    static defaultProps: {};
    refs: {
        [key: string]: React.ReactInstance;
        root: HTMLElement;
        sliderLine: HTMLElement;
        thumb: HTMLElement;
    };
    private _events;
    private _id;
    static ensurePropsValid(props: ISliderProps): ISliderProps;
    constructor(props?: ISliderProps);
    /**
     * Invoked when a component is receiving new props. This method is not called for the initial render.
     */
    componentWillReceiveProps(newProps: ISliderProps): void;
    componentWillUnmount(): void;
    render(): React.ReactElement<{}>;
    private _onMouseDownOrTouchStart(event);
    private _onMouseMoveOrTouchMove(event);
    private _onMouseUpOrTouchEnd();
    private _onKeyDown(event);
}
