import * as React from 'react';
import { ITextFieldProps } from './TextField.Props';
import './TextField.scss';
export interface ITextFieldState {
    value: string;
    /**
     * The validation error message.
     *
     * - If there is no validation error or we have not validated the input value, errorMessage is an empty string.
     * - If we have done the validation and there is validation error, errorMessage is the validation error message.
     */
    errorMessage: string;
}
export declare class TextField extends React.Component<ITextFieldProps, ITextFieldState> {
    static defaultProps: ITextFieldProps;
    refs: {
        [key: string]: React.ReactInstance;
        field: HTMLInputElement;
    };
    private _id;
    private _descriptionId;
    private _async;
    private _delayedValidate;
    private _isMounted;
    private _lastValidation;
    private _latestValidateValue;
    private _willMountTriggerValidation;
    constructor(props: ITextFieldProps);
    componentWillMount(): void;
    componentDidMount(): void;
    componentWillReceiveProps(newProps: ITextFieldProps): void;
    componentWillUnmount(): void;
    render(): JSX.Element;
    focus(): void;
    private _fieldClassName;
    private _errorMessage;
    private _renderTextArea();
    private _renderInput();
    private _onInputChange(event);
    private _validate(value);
    private _notifyAfterValidate(value, errorMessage);
}
