define([], function() { return "import * as React from 'react';\nimport { Dialog } from './Dialog';\nimport { IWithResponsiveModeState } from '../../utilities/decorators/withResponsiveMode';\n\nexport interface IDialogProps extends React.Props<Dialog>, IWithResponsiveModeState {\n  /**\n  * Whether the dialog is displayed.\n  * @default false\n  */\n  isOpen?: boolean;\n\n  /**\n  * The type of Dialog to display.\n  * @default DialogType.normal\n  */\n  type?: DialogType;\n\n  /**\n  * Whether the overlay is dark themed.\n  * @default true\n  */\n  isDarkOverlay?: boolean;\n\n  /**\n  * A callback function for when the Dialog is dismissed from the close button or light dismiss.\n  */\n  onDismiss?: (ev?: React.MouseEvent) => any;\n\n  /**\n  * The title text to display at the top of the dialog.\n  */\n  title?: string;\n\n  /**\n  * The subtext to display in the dialog.\n  */\n  subText?: string;\n\n  /**\n  * Whether the dialog can be light dismissed by clicking outside the dialog (on the overlay).\n  * @default false\n  */\n  isBlocking?: boolean;\n\n  /**\n  * Optional override for container class\n  */\n  containerClassName?: string;\n\n  /**\n  * Optional override content class\n  */\n  contentClassName?: string;\n\n  /**\n   * Sets the HTMLElement to focus on when exiting the FocusTrapZone.\n   * @default The element.target that triggered the Dialog.\n   */\n  elementToFocusOnDismiss?: HTMLElement;\n\n  /**\n   * Indicates if this Dialog will ignore keeping track of HTMLElement that activated the Dialog.\n   * @default false\n   */\n  ignoreExternalFocusing?: boolean;\n\n  /**\n   * Aria label on close button\n   */\n  closeButtonAriaLabel?: string;\n}\n\nexport enum DialogType {\n  /** Standard dialog */\n  normal,\n  /** Dialog with large header banner */\n  largeHeader,\n  /** Dialog with an 'x' close button in the upper-right corner */\n  close\n}"; });