module.exports = "import * as React from 'react';\nimport { Image } from './Image';\n\nexport interface IImageProps extends React.Props<Image> {\n\n   /**\n   * Image source to display.\n   */\n  src: string;\n\n   /**\n   * Alt text to put on the image.\n   */\n  alt?: string;\n\n   /**\n   * If provided, forces the image to be this width.\n   */\n  width?: number;\n\n  /**\n   * If provided, forces the image to be this height.\n   */\n  height?: number;\n\n  /**\n   * If true, adds the css class 'is-fadeIn' to the image.\n   */\n  shouldFadeIn?: boolean;\n\n  /**\n   * If provided, adds the indicated css class to the image.\n   */\n  className?: string;\n\n  /**\n   * Used to determine how to size the image to fit the dimensions of the component.\n   * If both dimensions are provided, then the image is fit using ImageFit.scale, otherwise ImageFit.none is used.\n   * @default See description\n   */\n  imageFit?: ImageFit;\n\n  /**\n   * Function to call when the image indicated by src fails to load. The parameter src will be the same\n   * as the original src property.\n   */\n  onError?: (src: string) => void;\n\n  /**\n   * Image source to display if an error occurs loading the image indicated by src.\n   */\n  errorSrc?: string;\n}\n\n/**\n * The possible methods that can be used to fit the image.\n */\nexport enum ImageFit {\n  /**\n   * The image is not scaled. The image is centered and cropped within the content box.\n   */\n  center,\n\n  /**\n   * The image is sized to maintain its aspect ratio while filling the element’s entire content box.\n   */\n  cover,\n\n  /**\n   * The image is scaled to match the size of the element's content box.\n   */\n  scale,\n\n  /**\n   * The image is not resized.\n   */\n  none\n}\n";