module.exports = "export interface ISliderProps {\n  /**\n   * Description label of the Slider\n   */\n  label?: string;\n\n  /**\n   * The initial value of the Slider\n   */\n  initialValue?: number;\n\n  /**\n   * The min value of the Slider\n   */\n  min: number;\n\n  /**\n   * The max value of the Slider\n   */\n  max: number;\n\n  /**\n   * The diffrrence between the two adjacent values of the Slider\n   */\n  step?: number;\n\n  /**\n   * Whether to show the value on the right of the Slider.\n   * If you want to show the value by yourself, you may want to set this value to false.\n   */\n  showValue?: boolean;\n\n  /**\n   * Callback when the value has been changed\n   */\n  onChanged?: (value: number) => void;\n\n  /**\n   * A description of the Slider for the benefit of screen readers.\n   */\n  ariaLabel?: string;\n\n  /**\n   * Whether or not the Slider is disabled.\n   */\n  isDisabled?: boolean;\n}";